/// class PD.Manage.Modules.ReportEditDialogCommand

PD.Manage.Modules.ReportEditDialogCommand =
PD.Commands.Command.extend({

    //===================================
    // PUBLIC METHODS
    //===================================

    setDefaults: function () {
        this.props("id", "report/edit-dialog");
        this.props("enabled", false);
        this.props("icon", PD.Path.to16x16("pencil.png"));
        this.props("label", "Edit");
        this.props("tooltip", "Edit the selected Report.");
        this.state("report", null);
    },

    setState: function (state) {
        this._super(state);
        this.props("enabled", this._isEnabled());
    },

    execute: function (e) {
        this._super(e);

        var report = this.state("report");

        this._showDialog(report.id, report.name);

    },

    //===================================
    // PRIVATE METHODS
    //===================================

    _isEnabled: function () {
        return this.state("report") != null
            && this.state("report").id != null;
    },

    _showDialog: function (id, name) {

        PDJS.Shared.Features.FeatureDialogForNhib.open({
            title: `Report | ${name}`,
            args: {
                targetId: id,
                targetType: "ProspectDirector.Web.Manage.Modules.Reports.ReportUIO",
                arbiterType: "ProspectDirector.Web.Manage.Modules.Reports.ReportArbiter"
            },
            callbacks: {
                "ok": (sender, e) => {

                    PD.context
                        .get_default()
                        .get_events()
                        .publish("report/edit", {
                            id: e.target.id
                        });

                }
            }
        }, {
            height: 550,
            width: 500,
        });

    }

});